﻿using System;
using Rhino;
using Rhino.DocObjects;
using Rhino.Geometry;
using Rhino.PlugIns;

namespace RhinoTestUserData
{
	public class RhinoTestUserDataPlugIn : Rhino.PlugIns.PlugIn
	{
		public static RhinoTestUserDataPlugIn Instance { get; private set; }

		public RhinoTestUserDataPlugIn()
		{
			Instance = this;
		}

		protected override LoadReturnCode OnLoad(ref System.String errorMessage)
		{
			RhinoDoc.BeforeTransformObjects += this.OnBeforeTransformObjects;
			return base.OnLoad(ref errorMessage);
		}

		private void OnBeforeTransformObjects(Object sender, RhinoTransformObjectsEventArgs e)
		{
			foreach (RhinoObject rhinoObj in e.Objects)
			{
				if (!rhinoObj.Geometry.UserDictionary.ContainsKey("TestUserData.BBoxCenter"))
					continue;

				Point3d readPoint = rhinoObj.Geometry.UserDictionary.GetPoint3d("TestUserData.BBoxCenter", Point3d.Unset);
				if (readPoint == Point3d.Unset)
					continue;

				readPoint.Transform(e.Transform);

				rhinoObj.Geometry.UserDictionary.Set("TestUserData.BBoxCenter", readPoint);
			}
		}
	}
}