﻿using Rhino;
using Rhino.Collections;
using Rhino.Commands;
using Rhino.DocObjects;
using Rhino.Geometry;
using Rhino.Input;
using Rhino.Input.Custom;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace RhinoTestUserData
{
	[Guid("640B3D19-2447-4236-846E-3E1BA99874D3")]
	public class UDSetUserDataCmd : Command
	{
		public static UDSetUserDataCmd Instance { get; protected set; }
		public override string EnglishName { get { return "UDSetUserData"; } }

		public UDSetUserDataCmd()
		{
			UDSetUserDataCmd.Instance = this;
		}

		protected override Result RunCommand(RhinoDoc doc, RunMode mode)
		{
			GetObject getObj = new GetObject();
			getObj.SetCommandPrompt("Select an object to set user data to");
			if (getObj.Get() != GetResult.Object)
				return Result.Cancel;

			ObjRef selectedObjRef = getObj.Object(0);
			RhinoObject selectedObj = selectedObjRef.Object();

			BoundingBox objectBBox = selectedObj.Geometry.GetBoundingBox(true);
			selectedObj.Geometry.UserDictionary.Set("TestUserData.BBoxCenter", objectBBox.Center);
			selectedObj.CommitChanges();

			return Result.Success;
		}
	}
}
